<template>
    <div>
        <header class="header">
            <h1 class="header-title"><a href="/">Language Dictionary <i class="fas fa-book"></i></a></h1>
            <login-form
                @login-successful="onLoginSuccessful($event)"
                @logout-successful="onLogoutSuccessful"
            />
        </header>

        <div class="container">
            <ais-instant-search
                :search-client="searchClient"
                :index-name="searchIndex"
                :search-function="searchFunction"
            >
                <vue-instantsearch-refresh
                    :refresh="refreshSearch"
                    @search-refreshed="refreshSearch = false"
                />
                <refinement-list
                    :items="dictionaries"
                    :current-refinement="currentDictionary"
                    @refinement-click="onRefinementClick"
                />

                <div class="search-panel">
                    <div class="tab-content">
                        <div class="search-panel__header-toolbar">
                            <div class="search-panel__header-toolbar-buttons">
                                <copy-button :dictionary="currentDictionary" />
                                <upload-button
                                    v-if="hasOwnership"
                                    :dictionaries="dictionaries"
                                    :dictionary="currentDictionary"
                                    @phrases-imported="refreshSearch = true"
                                />
                                <create-dictionary-button
                                    v-if="isAdmin"
                                    @dictionary-created="onDictionaryCreated"
                                />
                            </div>
                        </div>
                        <div class="search-panel__results">
                            <div class="search-panel__header-container">
                                <div class="search-panel__header">
                                    <search-box
                                        :can-create="hasOwnership"
                                        class="search-panel__header--search-box"
                                        :dictionary="currentDictionary"
                                        @phrase-created="refreshSearch = true"
                                        :placeholder="`Search${hasOwnership ? ' or create' : ''}...`"
                                    />
                                    <ais-logo />
                                </div>
                            </div>
                            <ais-hits>
                                <div slot-scope="{ items }">
                                    <ol class="ais-Hits-list">
                                        <phrase-hit
                                            v-for="(item, itemIndex) in items"
                                            :key="item.objectID"
                                            :item="item"
                                            :items="items"
                                            :item-index="itemIndex"
                                            :is-logged-in="user !== null"
                                            :current-item="currentItem"
                                            :has-ownership="hasOwnership"
                                            @on-phrase-click="currentItem = item"
                                            @blur="currentItem = null"
                                            @phrase-deleted="onPhraseDeleted"
                                            @phrase-updated="onPhraseUpdated"
                                        ></phrase-hit>
                                    </ol>
                                </div>
                            </ais-hits>
                        </div>
                    </div>
                </div>
            </ais-instant-search>
        </div>
    </div>
</template>

<script>
import algoliasearch from 'algoliasearch/lite';
import 'instantsearch.css/themes/algolia-min.css';

export default {
    data() {
        return {
            searchClient: algoliasearch(
                process.env.MIX_ALGOLIA_APP_ID,
                process.env.MIX_ALGOLIA_API_KEY,
            ),
            searchIndex: `${process.env.MIX_ALGOLIA_INDEX_PREFIX}_dictionary`,
            user: null,
            currentItem: null,
            isFirstSearch: true,
            currentDictionary: null,
            dictionaries: [],
            refreshSearch: false,
        };
    },

    mounted() {
        axios.get('dictionaries')
            .then(response => {
                this.dictionaries = response.data.dictionaries;

                if (this.dictionaries.length) {
                    this.currentDictionary = this.dictionaries[0];
                }
            });
    },

    methods: {
        searchFunction(helper) {
            if (this.isFirstSearch) {
                // Pre-select a dictionary on page load
                helper.state.disjunctiveFacetsRefinements = {
                    dictionary: ['Spanish'],
                };

                this.isFirstSearch = false;
            }

            helper.search();
        },

        onLoginSuccessful(user) {
            this.user = user;
        },

        onLogoutSuccessful() {
            this.user = null;
        },

        onPhraseDeleted() {
            this.searchClient.clearCache();

            this.$toasted.show('Phrase deleted');
        },

        onPhraseUpdated() {
            this.$toasted.show('Phrase updated');
        },

        onRefinementClick(item) {
            this.currentDictionary = item;
        },

        onDictionaryCreated(dictionary) {
            this.dictionaries.push(dictionary);
        },
    },

    computed: {
        isAdmin() {
            return this.user && this.user.isAdmin;
        },

        hasOwnership() {
            if (this.user === null) {
                return false;
            }

            if (this.user.isAdmin) {
                return true;
            }

            if (this.currentDictionary.owner === null) {
                return true;
            }

            return this.currentDictionary.owner === this.user.id;
        }
    },
};
</script>

<style>
body,
h1 {
    margin: 0;
    padding: 0;
}

body {
    font-family: -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, Helvetica,
    Arial, sans-serif, 'Apple Color Emoji', 'Segoe UI Emoji', 'Segoe UI Symbol';
    background-color: #CECECE;
}

.header {
    display: flex;
    align-items: center;
    min-height: 50px;
    padding: 0.5rem 1rem;
    background-color: #000000;
    color: #fff;
    margin-bottom: 1rem;
    justify-content: space-between;
}

@media screen and (max-width: 360px) {
    .header {
        flex-direction: column;
    }
}

.header a {
    color: #fff;
    text-decoration: none;
}

.header-title {
    font-size: 1.2rem;
    font-weight: normal;
}

.container {
    max-width: 1200px;
    margin: 0 auto;
    padding: 1rem;
}

.search-panel {
    display: flex;
    flex-direction: column;
}

.search-panel__results {
    margin-top: 1rem;
    flex: 3;
}

.search-panel__header-container {
    display: flex;
    justify-content: space-between;
}

.search-panel__header {
    display: flex;
    width: 100%;
}

@media screen and (max-width: 360px) {
    .search-panel__header-container {
        flex-direction: column-reverse;
    }

    .search-panel__header {
        flex-direction: column;
    }
}

.ais-Hits-list {
    margin-top: 0;
    margin-left: 0;
}

@media screen and (max-width: 360px) {
    .ais-Hits-item {
        width: 40%;
        margin-right: auto;
    }

    .ais-Hits-list {
        margin: 0;
    }
}

.ais-Hits {
    margin-top: 25px;
}

.ais-Hits-item-container > * {
    min-width: 0;
}

.ais-Hits-item-container {
    background-color: white;
}

.search-panel__header-toolbar {
    display: flex;
    justify-content: space-between;
    align-items: center;
}

.search-panel__header-toolbar-buttons {
    display: flex;
    flex-direction: row;
}

.search-panel__header-toolbar-buttons .mdc-button {
    margin-left: 15px;
}

@media screen and (max-width: 360px) {

    .search-panel__header-toolbar {
        flex-direction: column;
    }

    .search-panel__header-toolbar-buttons {
        width: 100%;
        justify-content: space-between;
        margin-top: 16px;
    }
}

.search-panel__header--search-box {
    width: 100%;
}

.search-panel__header--search-box .mdc-text-field {
    width: 100%;
}
</style>
